<template>
  <div class="app-container">
    <el-form v-show="showSearch" ref="queryForm" :inline="true" :model="queryParams" label-width="90px" size="small">
      <el-form-item label="名单类型" prop="whiteListType">
        <el-input
          v-model="queryParams.whiteListType"
          clearable
          placeholder="请输入名单类型"
          style="width: 240px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="名称" prop="whiteListName">
        <el-input
          v-model="queryParams.whiteListName"
          clearable
          placeholder="请输入名称"
          style="width: 240px"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建时间">
        <el-date-picker
          v-model="dateRange"
          end-placeholder="结束日期"
          range-separator="-"
          start-placeholder="开始日期"
          style="width: 240px"
          type="daterange"
          value-format="yyyy-MM-dd"
        ></el-date-picker>
      </el-form-item>
      <el-form-item label="状态" prop="configType">
        <el-select v-model="queryParams.status" clearable placeholder="请选择状态">
          <el-option
            v-for="dict in dict.type.sys_yes_no"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button icon="el-icon-search" size="mini" type="primary" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['system:config:add']"
          icon="el-icon-plus"
          plain
          size="mini"
          type="primary"
          @click="handleAdd"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          :disabled="multiple"
          icon="el-icon-plus"
          plain
          size="mini"
          type="info"
          @click="handlePublish"
        >批量发布
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          :disabled="multiple"
          icon="el-icon-plus"
          plain
          size="mini"
          type="info"
          @click="handleDelete"
        >批量删除
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="configList" @selection-change="handleSelectionChange">
      <el-table-column align="center" type="selection" width="55"/>
      <el-table-column align="center" label="白名单名称" prop="configId"/>
      <el-table-column :show-overflow-tooltip="true" align="center" label="说明" prop="configName"/>
      <el-table-column :show-overflow-tooltip="true" align="center" label="白名单类型" prop="configKey"/>
      <el-table-column :show-overflow-tooltip="true" align="center" label="数量" prop="configValue"/>
      <el-table-column align="center" label="创建时间" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" label="状态" prop="configType">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.sys_yes_no" :value="scope.row.configType"/>
        </template>
      </el-table-column>
      <el-table-column :show-overflow-tooltip="true" align="center" label="备注" prop="remark"/>

      <el-table-column align="center" class-name="small-padding fixed-width" label="操作">
        <template slot-scope="scope">
          <el-button
            icon="el-icon-edit"
            size="mini"
            type="text"
            @click="handleDown(scope.row)"
          >下架
          </el-button>
          <el-button
            icon="el-icon-edit"
            size="mini"
            type="text"
            @click="handlePublish(scope.row)"
          >发布
          </el-button>

          <el-button
            icon="el-icon-edit"
            size="mini"
            type="text"
            @click="handleConfig(scope.row)"
          >名单配置
          </el-button>

          <el-button
            v-hasPermi="['system:config:edit']"
            icon="el-icon-edit"
            size="mini"
            type="text"
            @click="handleEdit(scope.row)"
          >修改
          </el-button>

          <el-button
            v-hasPermi="['system:config:edit']"
            icon="el-icon-edit"
            size="mini"
            type="text"
            @click="handleDetail(scope.row)"
          >详情
          </el-button>

          <el-button
            v-hasPermi="['system:config:remove']"
            icon="el-icon-delete"
            size="mini"
            type="text"
            @click="handleDelete(scope.row)"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :limit.sync="queryParams.pageSize"
      :page.sync="queryParams.pageNum"
      :total="total"
      @pagination="getList"
    />

  </div>
</template>
<script>
import { delConfig, getConfig, listConfig } from '@/api/system/config'

export default {
  name: 'WhiteList',
  dicts: ['sys_yes_no'],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 参数表格数据
      configList: [],
      // 弹出层标题
      title: '',
      // 是否显示新增白名单弹出框
      addOpen: false,
      // 是否显示白名单配置弹出框
      configOpen: false,
      // 日期范围
      dateRange: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        whiteListName: undefined,
        whiteListType: undefined,
        status: undefined
      },
      // 表单参数
      form: {},
      // 白名单配置表单参数
      configForm: {
        addMode: 1,
        whiteListType: undefined,
        whitelistIds: undefined,
        remark: undefined
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询参数列表 */
    getList() {
      this.loading = true
      listConfig(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
          this.configList = response.rows
          this.total = response.total
          this.loading = false
        }
      )
    },
    // 表单重置
    reset() {
      this.form = {
        configId: undefined,
        configName: undefined,
        configKey: undefined,
        configValue: undefined,
        configType: 'Y',
        remark: undefined
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = []
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 新增按钮操作 */
    handleAdd() {
      const params = {
        type: 'add'
      }
      this.$tab.openPage('新增白名单', '/build/WhiteList/add/', params)
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.configId)
      this.single = selection.length != 1
      this.multiple = !selection.length
    },
    /** 修改按钮操作 */
    handleEdit(row) {
      const params = {
        type: 'edit'
      }
      this.$tab.openPage('编辑白名单', '/build/WhiteList/add/', params)
    },

    /** 白名单配置弹窗 **/
    handleConfig(row) {
      this.reset()
      const configId = row.configId || this.ids
      getConfig(configId).then(response => {
        this.$router.push({
          path: 'whiteList/addConfig'
        })
      })
    },

    /** 删除按钮操作 */
    handleDelete(row) {
      const configIds = row.configId || this.ids
      this.$modal.confirm('是否确认删除编号为"' + configIds + '"的数据项？').then(function() {
        return delConfig(configIds)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess('删除成功')
      }).catch(() => {
      })
    },

    /** 发布按钮操作 */
    handlePublish() {
      const configIds = row.configId || this.ids
      this.$modal.confirm('是否确认发布编号为"' + configIds + '"的数据项？').then(function() {
        //这里写发布操作
        return delConfig(configIds)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess('发布成功')
      }).catch(() => {
      })
    },

    /** 下架按钮操作 */
    handleDown() {
      const configIds = row.configId || this.ids
      this.$modal.confirm('是否确认下架编号为"' + configIds + '"的数据项？').then(function() {
        //这里写发布操作
        return delConfig(configIds)
      }).then(() => {
        this.getList()
        this.$modal.msgSuccess('下架成功')
      }).catch(() => {
      })
    },

    /** 查看详情按钮操作 */
    handleDetail(row) {
      if (row.type == 1) {
        this.$router.push({
          path: '/build/WhiteList/detail'
        })
      } else {
        this.$router.push({
          path: '/build/WhiteList/equepDetail'
        })
      }
    }

  }
}
</script>
